/*
Copyright 2015 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Compute exp(V) and log(1+W)
*/

#ifndef EXPANSIONS_H
#define EXPANSIONS_H

#include "polynomial.h"
#include "fields.h"

// exp(V)
int expand_exponential(Polynomial input_polynomial,Polynomial* output, Fields_Table fields);

// log(1+W)
int expand_logarithm(Polynomial input_polynomial, Polynomial* output, Fields_Table fields);


#endif
