/*
Copyright 2015 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Various tools
*/

#ifndef TOOLS_H
#define TOOLS_H

#include "types.h"

int factorial(int n);
int ipower(int n, int p);
long double dpower(long double x, int p);

// find an element in a list whose first element is its size
int list_find(int* list, int x);
// compare two lists
int list_cmp(int* list1, int* list2);

// find an element in a list whose first element is not its number of elements (skips first element)
int unlist_find(int* list, int size, int x);
// no error
int unlist_find_noerr(int* list, int size, int x);

// find an element in a list (checks first element)
int intlist_find(int* list, int size, int x);
// with error
int intlist_find_err(int* list, int size, int x);

// max and min
int max(int x1, int x2);
int min(int x1, int x2);

#endif
